# Makefile vs. Jamfile:
#
# If you'd rather use "make server/fuse_fs/bfs" instead
# of "jam bfs_fuse_fs" you may configure Genode to integrate
# this makefile like thus:
#
# - mkdir <genode>/repos/libports/src/server/fuse_fs/bfs
# - cd bfs....
# - ln -s <bfs-on-genode>/target.mk
#
# From then on, invoking make server/fuse_fs/bfs should work.


TARGET  := bfs_fuse_fs

SRC_CC  += fuse_fs_main.cc \
           init.cc

LIBS    := libc libfuse stdcxx bfs beroot


# sources:

vpath fuse_fs_main.cc	$(PRG_DIR)/..
vpath init.cc			$(REP_DIR)/src/lib/bfs



# headers for init.cc:

HaiSrc := /boot/system/sources/haiku  ##xxx Should host the source instead of relying on the .hpkg

INC_DIR += $(HaiSrc)/headers/private/fs_shell 
	# access directory.h ..etc
INC_DIR += $(PRG_DIR)/..


# warnings: disable extras

CC_CXX_WARN_STRICT =

